## org.apache.poi.ddf
Class EscherOptRecord

    java.lang.Object
      org.apache.poi.ddf.EscherRecord
          org.apache.poi.ddf.EscherOptRecord

public class EscherOptRecord
extends EscherRecord

The opt record is used to store property values for a shape. It is the key to determining the attributes of a shape. Properties can be of two types: simple or complex. Simple types are fixed length. Complex properties are variable length.

Author:
  Glen Stampoultzis

Field Summary
`static java.lang.String` `RECORD_DESCRIPTION`
`static short` `RECORD_ID`

Constructor Summary
`EscherOptRecord()`

Method Summary
`void` `addEscherProperty(EscherProperty prop)` Add a property to this record.
`int` `fillFields(byte[] data, int offset, EscherRecordFactory recordFactory)` This method deserializes the record from a byte array.
`java.util.List` `getEscherProperties()` The list of properties stored by this record.
`EscherProperty` `getEscherProperty(int index)` The list of properties stored by this record.
`short` `getOptions()` Automatically recalculate the correct option
`java.lang.String` `getRecordName()` The short name for this record
`int` `getRecordSize()` Returns the number of bytes that are required to serialize this record.
`int` `serialize(int offset, byte[] data, EscherSerializationListener listener)` This method serializes this escher record into a byte array.
`void` `sortProperties()` Records should be sorted by property number before being stored.
`java.lang.String` `toString()` Retrieve the string representation of this record.

Methods inherited from class org.apache.poi.ddf.EscherRecord
`clone, display, fillFields, getChild, getChildRecords, getInstance, getRecordId, isContainerRecord, readHeader, serialize, serialize, setChildRecords, setOptions, setRecordId`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### RECORD_ID

    public static final short RECORD_ID

See Also:
  Constant Field Values

### RECORD_DESCRIPTION

    public static final java.lang.String RECORD_DESCRIPTION

See Also:
  Constant Field Values

Constructor Detail

### EscherOptRecord

    public EscherOptRecord()

Method Detail

### fillFields

    public int fillFields(byte[] data,
                          int offset,
                          EscherRecordFactory recordFactory)

  This method deserializes the record from a byte array.

  Specified by:
    `fillFields` in class `EscherRecord`
  Parameters:
    `data` - The byte array containing the escher record information
    `offset` - The starting offset into `data`.
    `recordFactory` - May be null since this is not a container record.
  Returns:
    The number of bytes read from the byte array.

### serialize

    public int serialize(int offset,
                         byte[] data,
                         EscherSerializationListener listener)

  This method serializes this escher record into a byte array.

  Specified by:
    `serialize` in class `EscherRecord`
  Parameters:
    `offset` - The offset into `data` to start writing the record data to.
    `data` - The byte array to serialize to.
    `listener` - A listener to retrieve start and end callbacks. Use a `NullEscherSerailizationListener` to ignore these events.
  Returns:
    The number of bytes written.
  See Also:
    `NullEscherSerializationListener`

### getRecordSize

    public int getRecordSize()

  Returns the number of bytes that are required to serialize this record.

  Specified by:
    `getRecordSize` in class `EscherRecord`
  Returns:
    Number of bytes

### getOptions

    public short getOptions()

  Automatically recalculate the correct option

  Overrides:
    `getOptions` in class `EscherRecord`
  Returns:
    The options field for this record. All records have one.

### getRecordName

    public java.lang.String getRecordName()

  The short name for this record

  Specified by:
    `getRecordName` in class `EscherRecord`

### toString

    public java.lang.String toString()

  Retrieve the string representation of this record.

### getEscherProperties

    public java.util.List getEscherProperties()

  The list of properties stored by this record.

### getEscherProperty

    public EscherProperty getEscherProperty(int index)

  The list of properties stored by this record.

### addEscherProperty

    public void addEscherProperty(EscherProperty prop)

  Add a property to this record.

### sortProperties

    public void sortProperties()

  Records should be sorted by property number before being stored.

Copyright © 2003 Apache Software Foundation.